<html>
<head>
<title>Cheems</title>
<style>
body {
  background-size: 380px;
  background-position: 30px 40px;
  margin: 0;
  padding: 0;
}

body.showbg {
  background-image: url(https://i.redd.it/pmf7ztkytz241.jpg);  
}

#pic {
  width: 400px;
  height: 400px;
  border: 1px solid red;
  margin: 30px;
}

#code {
  position: absolute;
  width: 80vh;
  height: 30vh;
  bottom: 30px;
  right: 30px;
}

#points {
  position: absolute;
  width: 100px;
  height: 40vh;
  top: 30px;
  right: 30px;
}

#code textarea, #points textarea {
  width: 100%;
  height: 100%;
}
</style>
<script>
const points = ``.trim()

class Cheems {
  constructor() {
    this.txt = this.id('txt')
    this.pic = this.id('pic')
    this.pointsTxt = this.id('pointsTxt')
    this.pointsTxt.value = points.trim()
    this.updateCode()
    this.pointsTxt.addEventListener('input', this.updateCode)
    this.txt.addEventListener('input', this.warnAndUpdatePic)
    this.pic.addEventListener('mousedown', this.click)
    this.id('toggleBg').addEventListener('click', this.toggleBg)
    this.toggleBg()
    this.warned = false
  }
  
  id(id) {
    return document.getElementById(id)
  }
  
  updateCode = () => {
    const points = this.pointsTxt.value.length ? "M " + this.pointsTxt.value.split("\n").join(" L ") : ''
    this.txt.value = `<svg viewBox="0 0 1000 1000"  style="color: rgba(0, 0, 0, 0.5)">
  <path d="${points}" fill="currentColor" />
</svg>`
    this.updatePic()
  }
  
  warnAndUpdatePic = () => {
    if (!this.warn) {
      alert("Be sure to back up your changes! Changes will be lost when clicking in the red box or editing the points in the upper-right corner.")
      this.warn = true
    }
    this.updatePic()
  }
  
  updatePic = () => {
    this.pic.innerHTML = this.txt.value
  }
  
  click = ({clientX: x, clientY: y}) => {
    const {left: rx, top: ry} = this.pic.getBoundingClientRect()
    this.pointsTxt.value = `${Math.floor((x - rx) * 2.5)} ${Math.floor((y - ry) * 2.5)}\n` + this.pointsTxt.value
    this.updateCode()
  }
  
  toggleBg = () => {
    document.body.classList.toggle('showbg')
  }
}

document.addEventListener('DOMContentLoaded', () => new Cheems())
</script>
</head>
<body>
<div id="pic">
  
</div>
<div id="points">
  <textarea id="pointsTxt">
    
  </textarea>
  <button id="toggleBg">Toggle Background</button>
</div>
<div id="code">
  <textarea id="txt">
  </textarea>
</div>
</body>
